package polyglot.ext.predj.ast;

import polyglot.ast.*;
import polyglot.ext.jl.ast.*;
import polyglot.ext.predj.visit.*;
import polyglot.types.*;

import java.util.*;

/** An AST node representing a dispatcher for a set of dispatcher mates. **/
public interface PredJDispatcher extends ClassMember {

	// a list of PredJMethodDecls
    public List dispatcherMates();
    
	// returns a representation of the partial order among the
	// mates associated with this dispatcher.  it is represented
	// as an array indexed by dispatcher mate number.  each element of
	// the array is a list of the mate numbers (Integers) of the other
	// mates that the given one (transitively) overrides.
    public List[] partialOrder();

	// perform completeness and ambiguity checking
    public Node implementationSideTypeCheck(
	ImplementationSideTypeChecker itc) throws SemanticException;
}

