package polyglot.ext.predj.ast;

import polyglot.ast.*;
import polyglot.types.*;

import java.util.*;

import polyglot.ext.jl5.ast.JL5MethodDecl;

/** An AST node for method declarations in PredJava. **/
public interface PredJMethodDecl extends JL5MethodDecl {

	// does this method have a predicate?
    public boolean hasPredicate();
    
	// is the given method a dispatcher mate of this one?
    public boolean hasDispatcherMate(PredJMethodDecl m);

	// record the fact that this method has mates
    public void setHasMates();
    
	// set this mate's unique mate number, used to give it
	// a unique name in the Java translation
    public void setMateNumber(int i);
    
    public int mateNumber();

	// does this method have any dispatcher mates?
    public boolean hasMates();

	// this method already exists in MethodDecl, but it is protected.
	// making it public allows it to be accessed by PredJTranslator.
    public MethodInstance makeMethodInstance(ClassType ct, TypeSystem ts)
	throws SemanticException;

}
