package polyglot.ext.predj.tools;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;

public class PredJAntTask extends PolyglotAntTask {
	/**
	 * Source version passed to javac.
	 */
	protected String source;

	/**
	 * Target version passed to javac.
	 */
	protected String target;

    public void init() {
	super.init();
	extensionName = "predj";
	srcExt = "pj";
	noOutput = true;
	source = null;
	target = null;
    }

	// Implement source and target parameters by modifying the post parameter
	public void execute() throws BuildException {
		if (source != null) {
			if (post == null) {
				post = "javac";
			}
			post += " -source " + source;
		}
		if (target != null) {
			if (post == null) {
				post = "javac";
			}
			post += " -target " + target;
		}

		super.execute();
	}

	protected void dumpDetails() {
		super.dumpDetails();
		log("source = " + source, Project.MSG_DEBUG);
		log("target = " + target, Project.MSG_DEBUG);
	}

	public void setSource(String source) {
		this.source = source;
	}

	public void setTarget(String target) {
		this.target = target;
	}
}
