package polyglot.ext.predj.types;

// an interface for interacting with CVC3

public class CVC3Interface_c extends CVCLInterface_c {

    public CVC3Interface_c(PredJTypeSystem ts) {
	super(ts);
    }
    
	// Unlike CVC Lite, CVC3 doesn't seem to allow $ in identifiers.
    protected String CVC_PathSep() {
	return "__sep__";
    }

    protected String executableName() {
	return "cvc3";
    }

    protected String funDecl(String name, String[] argTypes, String resType) {
        String t;
        if (argTypes.length == 0)
            t = resType;
        else {
            if (argTypes.length == 1)
                t = argTypes[0];
            else
                t = "(" + strList(argTypes, ", ") + ")";
            t = t + " -> " + resType;
        }
	return decl(name, t);
    }

    protected int interpretCVCOutput(String s) {
	if (s.endsWith("Invalid."))
	    return -1;
	else {
	    try {
		return super.interpretCVCOutput(s);
	    } catch(RuntimeException e) {
		throw new RuntimeException("No response from CVC3.  " +
					   "It does not understand the input.");
	    }
	}
    }
}