
package polyglot.ext.predj.types;

import polyglot.types.Context;
import polyglot.types.*;

import polyglot.ext.jl5.types.*;

import polyglot.ast.Expr;

import java.util.Map;

/** A context that can locally refine the types of variables and fields in
    scope, based on specializer information. **/

public interface PredJContext extends JL5Context {

	/** Adds a mapping from a formal to its refined type. **/
    public void addRefinedFormalType(VarInstance var, Type t);

	// does this formal parameter have a specialized type in the
	// current context?
    public boolean formalIsSpecialized(String name);

	// add a mapping from a variable bound in a predicate to its
	// associated expression
    public void addPredicateVarBinding(String name, Expr def,
				       boolean isSpecialized);

    public Expr getPredicateVarBinding(String name);

    public boolean varBindingIsSpecialized(String name);

	// this method is provided by Context_c, but it's not listed
	// in the Context interface.
    public VarInstance findVariableInThisScope(String name);

    public void removeVariableFromThisScope(VarInstance var);
}
    
