package polyglot.ext.predj.types;

import polyglot.types.*;

import java.util.*;
import java.io.*;

/** The type information for a PredJDispatcher **/
public interface PredJDispatcherInstance extends Serializable {

	// a list of PredJMethodInstances
    public List dispatcherMates();
    
    public boolean hasAbstractMethod();
    
	// returns a representation of the partial order among the
	// mates associated with this dispatcher.  it is represented
	// as an array indexed by dispatcher mate number.  each element of
	// the array is a list of the mate numbers (Integers) of the other
	// mates that the given one (transitively) overrides.
    public List[] partialOrder();


    public boolean isComplete(ClassType ct, PredJTypeSystem ts);

    public void checkUnambiguity(PredJTypeSystem ts) throws SemanticException;

    public void checkSatisfiablePredicates(PredJTypeSystem ts) throws SemanticException;
}

