package polyglot.ext.predj.types;

import polyglot.types.*;
import polyglot.ast.Binary;

import java.util.*;

// the type information for a binary expression (addition,
// subtraction, multiplication) appearing in a predicate
public class PredicateBinary_c extends Predicate_c
    implements PredicateBinary {

    protected Predicate left;
    protected Binary.Operator op;
    protected Predicate right;

    public PredicateBinary_c(Predicate left, Binary.Operator op,
			     Predicate right, Type type) {
	super(type);
	this.left = left;
	this.op = op;
	this.right = right;
    }

    public Predicate left() {
	return left;
    }

    public Predicate right() {
	return right;
    }

    public Binary.Operator operator() {
	return op;
    }

    public Set specializers() {
	Set s = right().specializers();
	s.addAll(left().specializers());
	return s;
    }

    public Set targets() {
	Set s1 = left.targets();
	s1.addAll(right.targets());
	return s1;
    }
    public Set names() {
	Set s1 = left.names();
	s1.addAll(right.names());
	return s1;
    }
}
