package polyglot.ext.predj.types;

import polyglot.types.*;
import polyglot.ast.Special;

import java.util.*;

// the type information for a standalone (i.e., not part of a greater
// target like this.f.g) use of 'this' in a predicate
public class PredicateSpecial_c extends Predicate_c
    implements PredicateSpecial {

    protected Special.Kind kind;

    public PredicateSpecial_c(Special.Kind kind, Type type) {
	super(type);
	this.kind = kind;
    }

    public Special.Kind kind() {
	return kind;
    }

    public String name() {
	if (kind == Special.THIS) {
	    return "this";
	} else {
	    throw new RuntimeException("Currently not handling \'super\' " +
				       "in predicates.");
	}
    }
    
    public Set specializers() {
	Set s = new HashSet();
	s.add(type());
	return s;
    }

    public Set targets() {
	Set s = new HashSet();
	s.add(this);
	return s;	
    }
}
