package polyglot.ext.predj.types;

import polyglot.types.*;

import java.util.*;

// the type information for a target (variable or path to a field)
// appearing in a predicate
public class PredicateTarget_c extends Predicate_c
    implements PredicateTarget {

    protected String name;
    
    public PredicateTarget_c(String name, Type type) {
	super(type);
	this.name = name;
    }

    // TODO: this used to be @PredicateTarget_c, is this the desired behavior?
    public boolean equals(Object o) {
	if (!(o instanceof PredicateTarget))
	    return super.equals(o);

	PredicateTarget p = (PredicateTarget) o;
	if (!type().equals(p.type()))  // Added jRyder
	    return false;
	return name.equals(p.name());
    }

    public int hashCode() {
	return name.hashCode();
    }
    
    public String name() {
	return name;
    }

    public String toString() {
	return name;
    }
    
	// we add the static type of the target as a specializer because
	// we will assert an axiom
	// (instanceof(target, static type) OR target == null)
    public Set specializers() {
	Set s = new HashSet();
	if (type().isReference()) {
	    s.add(type());
	}
	return s;
    }

    public Set targets() {
	Set s = new HashSet();
	s.add(this);
	return s;
    }
}
