package polyglot.ext.predj.types;

import polyglot.types.*;
import polyglot.ast.Unary;

import java.util.*;

// the type information for a unary expression (currently just unary
// minus) appearing in a predicate
public class PredicateUnary_c extends Predicate_c
    implements PredicateUnary {

    protected Unary.Operator op;
    protected Predicate base;

    public PredicateUnary_c(Unary.Operator op, Predicate base, Type type) {
	super(type);
	this.op = op;
	this.base = base;
    }

    public Predicate base() {
	return base;
    }

    public Unary.Operator operator() {
	return op;
    }

    public Set specializers() {
	return base.specializers();
    }
    
    public Set targets() {
	return base.targets();
    }
    
    public Set names() {
	return base.names();
    }
}
