package polyglot.ext.predj.visit;

import java.util.ArrayList;


public class MethodFamily {

	//Declare variables
	protected String name;						//Name of method family
	protected ArrayList<Predicate> predicates;	//ArrayList of predicates
	
	//Empty constructor
	public MethodFamily(){
	}
	
	//Single parameter constructor
	public MethodFamily(String name){
		this.name = name;
		predicates = new ArrayList<Predicate>();
	}
	
	//Add Predicate to method family
	public void addPredicate(Predicate predicate){
		predicates.add(predicate);
	}
	
	//Get ArrayList of Predicates in method family
	public ArrayList<Predicate> getPredicates(){
		return predicates;
	}
	
	//Gets specific predicate from method family
	public Predicate getPredicate(int i)
	{
		return predicates.get(i);
	}

	//Gets the size of the predicate array
	public int size()
	{
		return predicates.size();
	}

	//Get name of the method family
	public String getMethodFamilyName(){
		return name;
	}
	
}
